Index: test/FormTest/FormTest.cpp
===================================================================
--- test/FormTest/FormTest.cpp	(revision 1792)
+++ test/FormTest/FormTest.cpp	(revision 1793)
@@ -55,7 +55,7 @@
     // Name
     y -= 10000.0 * CONVERSION_CONSTANT;
     painter.DrawText( x, y, "Your Name:" );
-    PdfTextField textName( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT, 
+    PdfTextField textName( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT,
                                            80000.0 * CONVERSION_CONSTANT, h ), pDoc );
     textName.SetFieldName("field_name");
     textName.SetBorderColor( 1.0 );
@@ -63,16 +63,16 @@
     // E-Mail
     y -= 10000.0 * CONVERSION_CONSTANT;
     painter.DrawText( x, y, "E-Mail Address:" );
-    PdfTextField textMail( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT, 
+    PdfTextField textMail( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT,
                                            80000.0 * CONVERSION_CONSTANT, h ), pDoc );
     textMail.SetFieldName("field_mail");
     textMail.SetBorderColor( 1.0 );
-    
+
     // Interest
     y -= 10000.0 * CONVERSION_CONSTANT;
     painter.DrawText( x, y, "Job:" );
 
-    PdfComboBox comboJob( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT, 
+    PdfComboBox comboJob( pPage, PdfRect( 80000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT,
                                           80000.0 * CONVERSION_CONSTANT, h ), pDoc );
     comboJob.SetFieldName("field_combo");
     comboJob.SetBorderColor( 1.0 );
@@ -85,7 +85,7 @@
     // Open Source
     y -= 11000.0 * CONVERSION_CONSTANT;
     painter.DrawText( x, y, "I wan't to use PoDoFo in an Open Source application" );
-    PdfCheckBox checkOpenSource( pPage, PdfRect( 120000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT, 
+    PdfCheckBox checkOpenSource( pPage, PdfRect( 120000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT,
                                                  h, h ), pDoc );
     checkOpenSource.SetFieldName("field_check_oss");
 
@@ -92,7 +92,7 @@
     // Commercial
     y -= 11000.0 * CONVERSION_CONSTANT;
     painter.DrawText( x, y, "I wan't to use PoDoFo in a commercial application" );
-    PdfCheckBox checkCom( pPage, PdfRect( 120000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT, 
+    PdfCheckBox checkCom( pPage, PdfRect( 120000.0 * CONVERSION_CONSTANT, y - 2500.0 * CONVERSION_CONSTANT,
                                           h, h ), pDoc );
     checkCom.SetFieldName("field_check_com");
 
@@ -118,10 +118,10 @@
     buttonClear.SetBackgroundColor( 0.5 );
 
     PdfAction actionClear( ePdfAction_JavaScript, pDoc );
-    actionClear.SetScript( 
+    actionClear.SetScript(
         PdfString("this.getField(\"field_name\").value = \"\";" \
                   "this.getField(\"field_mail\").value = \"\";" \
-                  "this.getField(\"field_combo\").value = \"\";" 
+                  "this.getField(\"field_combo\").value = \"\";"
                   "this.getField(\"field_check_oss.\").checkThisBox( 0, false );" \
                   "this.getField(\"field_check_com.\").checkThisBox( 0, false );" \
                   "this.getField(\"field_comment\").value = \"\";" ) );
@@ -128,11 +128,11 @@
 
 
     buttonClear.SetMouseDownAction( actionClear );
-                  
+
     PdfAction actionSubmit( ePdfAction_SubmitForm, pDoc );
 
     buttonSend.SetMouseDownAction( actionSubmit );
-    
+
     painter.FinishPage();
 }
 
@@ -156,7 +156,7 @@
 
 
     PdfAction action( ePdfAction_JavaScript, pDoc );
-    action.SetScript( 
+    action.SetScript(
         PdfString("var str = this.getField(\"TextFieldName\").value;" \
                   "var j = 4*5;" \
                   "app.alert(\"Hello World! 4 * 5 = \" + j + \" Text Field: \" + str );") );
@@ -201,7 +201,7 @@
     listBox.SetSelectedItem( 2 );
 }
 
-void FillTextField( PdfTextField & rField ) 
+void FillTextField( PdfTextField & rField )
 {
     const char* pszCur = rField.GetText().GetString();
     std::cout << "  Current value:" << (pszCur ? pszCur : "") << std::endl;
@@ -224,13 +224,13 @@
     }
 }
 
-void FillListField( PdfListField & rField ) 
+void FillListField( PdfListField & rField )
 {
-    const char* pszCur = ( rField.GetSelectedItem() == -1 ? NULL : 
+    const char* pszCur = ( rField.GetSelectedItem() == -1 ? NULL :
                            rField.GetItemDisplayText( rField.GetSelectedItem() ).GetString() );
     std::cout << "  Current value:" << (pszCur ? pszCur : "") << std::endl;
     std::cout << "  Values:" << std::endl;
-    
+
     for( int i=0;i<static_cast<int>(rField.GetItemCount());i++ )
     {
         pszCur = rField.GetItemDisplayText( i ).GetString();
@@ -245,7 +245,7 @@
         rField.SetSelectedItem( nValue );
 }
 
-void FillForm( const char* pszFilename, const char* pszOutput ) 
+void FillForm( const char* pszFilename, const char* pszOutput )
 {
     PdfMemDocument doc( pszFilename );
     PdfPage*       pPage;
@@ -281,7 +281,7 @@
                 case ePdfField_TextField:
                 {
                     std::cout << "TextField" << std::endl;
-                    PdfTextField text( field ); 
+                    PdfTextField text( field );
                     FillTextField( text );
                     break;
                 }
@@ -289,7 +289,7 @@
                 {
                     std::cout << "ComboBox" << std::endl;
                     PdfListField lst( field );
-                    FillListField( lst ); 
+                    FillListField( lst );
                     break;
                 }
                 case ePdfField_ListBox:
@@ -296,7 +296,7 @@
                 {
                     std::cout << "ListBox" << std::endl;
                     PdfListField lst( field );
-                    FillListField( lst ); 
+                    FillListField( lst );
                     break;
                 }
                 case ePdfField_Signature:
@@ -315,7 +315,7 @@
     doc.Write( pszOutput );
 }
 
-int main( int argc, char* argv[] ) 
+int main( int argc, char* argv[] )
 {
     PdfPage*            pPage;
 
@@ -323,26 +323,32 @@
     {
         printf("Usage: FormTest [output_filename]\n");
         printf("       - Create a new example PDF form\n");
-        printf("       Formtest [input_filename] [output_filename]\n"); 
+        printf("       Formtest [input_filename] [output_filename]\n");
         printf("       - Fill out an existing form and save it to a PDF file\n");
         return 0;
     }
 
-    if( argc == 3 )
-    {
-        TEST_SAFE_OP( FillForm( argv[1], argv[2] ) );
-    }
-    else
-    {
-        PdfStreamedDocument writer( argv[1] );
+    try {
+        if( argc == 3 )
+        {
+            TEST_SAFE_OP( FillForm( argv[1], argv[2] ) );
+        }
+        else
+        {
+            PdfStreamedDocument writer( argv[1] );
 
-        pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
-        TEST_SAFE_OP( CreateComplexForm( pPage, &writer ) );
+            pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
+            TEST_SAFE_OP( CreateComplexForm( pPage, &writer ) );
 
-        pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
-        TEST_SAFE_OP( CreateSimpleForm( pPage, &writer ) );
+            pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
+            TEST_SAFE_OP( CreateSimpleForm( pPage, &writer ) );
 
-        TEST_SAFE_OP( writer.Close() );
+            TEST_SAFE_OP( writer.Close() );
+        }
+    } catch( PdfError & e ) {
+        std::cerr << "Error: An error " << e.GetError() << " ocurred." << std::endl;
+        e.PrintErrorMsg();
+        return e.GetError();
     }
 
     return 0;
Index: test/LargeTest/LargeTest.cpp
===================================================================
--- test/LargeTest/LargeTest.cpp	(revision 1792)
+++ test/LargeTest/LargeTest.cpp	(revision 1793)
@@ -39,7 +39,7 @@
  
     try {
         pFont  = pDoc->CreateFont( pszFontName );
-    } catch ( const PdfError & e ) {
+    } catch ( PdfError & e ) {
         e.PrintErrorMsg();
         return;
     }
@@ -86,7 +86,7 @@
     try {
         pImage->LoadFromFile( pszImagePath );
     }
-    catch( const PdfError & e ) 
+    catch( PdfError & e ) 
     {
         e.PrintErrorMsg();
     }
Index: test/ObjectParserTest/ObjectParserTest.cpp
===================================================================
--- test/ObjectParserTest/ObjectParserTest.cpp	(revision 1792)
+++ test/ObjectParserTest/ObjectParserTest.cpp	(revision 1793)
@@ -206,7 +206,7 @@
 
         cerr << "  -> Has Stream, loading ... " << flush;
         PdfMemStream * const ps = dynamic_cast<PdfMemStream*>(obj.GetStream());
-        assert(ps);
+        PODOFO_ASSERT(ps);
         cerr << " ok, length: " << ps->GetLength() << endl;
 
         ps->GetFilteredCopy( &pBuffer, &lLen );
@@ -214,6 +214,8 @@
         cerr << "Data:\n" << endl;
         cerr.write( pBuffer, lLen );
         cerr << "\n====\n" << endl;
+
+        podofo_free( pBuffer );
     }
 
     string str;
@@ -297,7 +299,7 @@
 // This may only be used for objects without associated streams.
 void TestObject_String( const string & sData, long lObjNo, long lGenNo, const char * expectedData )
 {
-    TestObject_String(sData, lObjNo, lGenNo, expectedData != NULL, string(expectedData), false);
+    TestObject_String(sData, lObjNo, lGenNo, expectedData != NULL, string( expectedData ? expectedData : "" ), false);
 }
 
 // Test an object stored in a file against the expected value, also a file (if provided).
@@ -404,7 +406,7 @@
         "endobj\n";
 
 // Comment tokenizer test adapted from PDF Reference, section 3.1.2 . Should parse as [ /abc 123 ] .
-const char* pszCommentObject       = "91 0 obj\n[/abc\% comment {/%) blah blah blah\n123]\nendobj\n";
+const char* pszCommentObject       = "91 0 obj\n[/abc% comment {/%) blah blah blah\n123]\nendobj\n";
 
 // Use a FULL statement in this macro, it will not add any trailing
 // semicolons etc.
Index: test/ParserTest/ParserTest.cpp
===================================================================
--- test/ParserTest/ParserTest.cpp	(revision 1792)
+++ test/ParserTest/ParserTest.cpp	(revision 1793)
@@ -205,7 +205,7 @@
                     parser.SetPassword( pw );
                 
                 bIncorrectPw = false;
-            } catch( const PdfError & e ) {
+            } catch( PdfError & e ) {
                 if( e.GetError() == ePdfError_InvalidPassword ) 
                 {
                     cout << endl << "Password :";
Index: test/SignTest/SignTest.cpp
===================================================================
--- test/SignTest/SignTest.cpp	(revision 1792)
+++ test/SignTest/SignTest.cpp	(revision 1793)
@@ -51,7 +51,7 @@
 }
 
 
-int main( int argc, char* argv[] ) 
+int main( int argc, char* argv[] )
 {
     PdfPage*            pPage;
 
@@ -62,42 +62,47 @@
         return 0;
     }
 
-    PdfSignOutputDevice signer(argv[1]);
-	// Reserve space for signature
-    signer.SetSignatureSize(1024);
+    try {
+        PdfSignOutputDevice signer(argv[1]);
+        // Reserve space for signature
+        signer.SetSignatureSize(1024);
 
-	PdfStreamedDocument writer( &signer, PoDoFo::ePdfVersion_1_5 );
-    // Disable default appearance
-    writer.GetAcroForm(ePdfCreateObject, PdfAcroForm::ePdfAcroFormDefaultAppearance_None);
+        PdfStreamedDocument writer( &signer, PoDoFo::ePdfVersion_1_5 );
+        // Disable default appearance
+        writer.GetAcroForm(ePdfCreateObject, PdfAcroForm::ePdfAcroFormDefaultAppearance_None);
 
-    pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
-    TEST_SAFE_OP( CreateSimpleForm( pPage, &writer, *signer.GetSignatureBeacon() ) );
+        pPage = writer.CreatePage( PdfPage::CreateStandardPageSize( ePdfPageSize_A4 ) );
+        TEST_SAFE_OP( CreateSimpleForm( pPage, &writer, *signer.GetSignatureBeacon() ) );
 
-    TEST_SAFE_OP( writer.Close() );
+        TEST_SAFE_OP( writer.Close() );
 
-    // Adjust ByteRange for signature
-    if(signer.HasSignaturePosition()) {
-        signer.AdjustByteRange();
-		
-		// read data for signature and count it
-		signer.Seek(0);
+        // Adjust ByteRange for signature
+        if(signer.HasSignaturePosition()) {
+            signer.AdjustByteRange();
 
-		// generate digest and count signature
-		// use NSS, MS Crypto API or OpenSSL 
-		// to generate signature in DER format
-		char buff[65536];
-		size_t len;
-		while( (len = signer.ReadForSignature(buff, 65536))>0 )
-		{
-		}
+            // read data for signature and count it
+            signer.Seek(0);
 
-		// Paste signature to the file
-        PdfData sigData("my-real-signature");
-        signer.SetSignature(sigData);
-    }
+            // generate digest and count signature
+            // use NSS, MS Crypto API or OpenSSL
+            // to generate signature in DER format
+            char buff[65536];
+            size_t len;
+            while( (len = signer.ReadForSignature(buff, 65536))>0 )
+            {
+            }
 
-	signer.Flush();
+            // Paste signature to the file
+            PdfData sigData("my-real-signature");
+            signer.SetSignature(sigData);
+        }
 
+        signer.Flush();
+    } catch( PdfError & e ) {
+        std::cerr << "Error: An error " << e.GetError() << " ocurred." << std::endl;
+        e.PrintErrorMsg();
+        return e.GetError();
+    }
 
     return 0;
 }
Index: test/TokenizerTest/TokenizerTest.cpp
===================================================================
--- test/TokenizerTest/TokenizerTest.cpp	(revision 1792)
+++ test/TokenizerTest/TokenizerTest.cpp	(revision 1793)
@@ -48,7 +48,7 @@
             printf("Got token: %s\n", pszToken );
         }
 
-    } catch( const PdfError & e ) {
+    } catch( PdfError & e ) {
         e.PrintErrorMsg();
         return e.GetError();
     }
Index: test/WatermarkTest/WatermarkTest.cpp
===================================================================
--- test/WatermarkTest/WatermarkTest.cpp	(revision 1792)
+++ test/WatermarkTest/WatermarkTest.cpp	(revision 1793)
@@ -72,7 +72,7 @@
     try {
         WatermarkFile( argv[1], argv[2] );
     } 
-    catch( const PdfError & e ) 
+    catch( PdfError & e ) 
     {
         e.PrintErrorMsg();
         return e.GetError();
Index: test/unit/EncodingTest.cpp
===================================================================
--- test/unit/EncodingTest.cpp	(revision 1792)
+++ test/unit/EncodingTest.cpp	(revision 1793)
@@ -332,7 +332,7 @@
     try {
 	pEncoding->GetCharCode( pEncoding->GetFirstChar() );
     } 
-    catch( const PdfError & rError ) 
+    catch( PdfError & rError ) 
     {
 	// This may not throw!
 	rMsg = "pEncoding->GetCharCode( pEncoding->GetFirstChar() ) failed";
@@ -342,7 +342,7 @@
     try {
 	pEncoding->GetCharCode( pEncoding->GetFirstChar() - 1 );
     } 
-    catch( const PdfError & rError ) 
+    catch( PdfError & rError ) 
     {
 	// This has to throw!
 	exception = true;
@@ -357,7 +357,7 @@
     try {
 	pEncoding->GetCharCode( pEncoding->GetLastChar() );
     } 
-    catch( const PdfError & rError ) 
+    catch( PdfError & rError ) 
     {
 	// This may not throw!
 	rMsg = "pEncoding->GetCharCode( pEncoding->GetLastChar()  ); failed";
@@ -368,7 +368,7 @@
     try {
 	pEncoding->GetCharCode( pEncoding->GetLastChar() + 1 );
     } 
-    catch( const PdfError & rError ) 
+    catch( PdfError & rError ) 
     {
 	// This has to throw!
 	exception = true;
Index: test/unit/EncryptTest.cpp
===================================================================
--- test/unit/EncryptTest.cpp	(revision 1792)
+++ test/unit/EncryptTest.cpp	(revision 1793)
@@ -238,7 +238,7 @@
 
             // Must throw an exception
             CPPUNIT_FAIL("Encrypted file not recognized!");
-        } catch( const PdfError & e ) {
+        } catch( PdfError & e ) {
             if( e.GetError() != ePdfError_InvalidPassword ) 
             {
                 CPPUNIT_FAIL("Invalid encryption exception thrown!");
@@ -272,7 +272,7 @@
 
             // Must throw an exception
             CPPUNIT_FAIL("Encrypted file not recognized!");
-        } catch( const PdfError & e ) {
+        } catch( PdfError & e ) {
             if( e.GetError() != ePdfError_InvalidPassword ) 
             {
                 CPPUNIT_FAIL("Invalid encryption exception thrown!");
Index: tools/podofocrop/podofocrop.cpp
===================================================================
--- tools/podofocrop/podofocrop.cpp	(revision 1792)
+++ tools/podofocrop/podofocrop.cpp	(revision 1793)
@@ -161,7 +161,11 @@
         if( strncmp( "%%BoundingBox: ", sLine.c_str(), 15 ) == 0 )
         {
             int x, y, w, h;
-            sscanf(sLine.c_str()+15, "%i %i %i %i\n", &x, &y, &w, &h);
+            if( sscanf( sLine.c_str() + 15, "%i %i %i %i\n", &x, &y, &w, &h ) != 4 )
+            {
+                printf( "Failed to read bounding box's four numbers from '%s'\n", sLine.c_str() + 15 );
+                exit( 1 );
+            }
             curRect = PdfRect( static_cast<double>(x), 
                                static_cast<double>(y),
                                static_cast<double>(w-x),
Index: tools/podofogc/podofogc.cpp
===================================================================
--- tools/podofogc/podofogc.cpp	(revision 1792)
+++ tools/podofogc/podofogc.cpp	(revision 1793)
@@ -61,7 +61,7 @@
                     parser.SetPassword( pw );
                 
                 bIncorrectPw = false;
-            } catch( const PdfError & e ) {
+            } catch( PdfError & e ) {
                 if( e.GetError() == ePdfError_InvalidPassword ) 
                 {
                     cout << endl << "Password :";
Index: tools/podofoimpose/impositionplan.cpp
===================================================================
--- tools/podofoimpose/impositionplan.cpp	(revision 1792)
+++ tools/podofoimpose/impositionplan.cpp	(revision 1793)
@@ -57,7 +57,8 @@
 		destPage ( 0 ),
 		rotate ( 0 ),
 		transX ( 0 ),
-		transY ( 0 )
+		transY ( 0 ),
+		duplicateOf( 0 )
 {};
 
 void PageRecord::load ( const std::string& buffer, const std::map<std::string, std::string>& vars )
Index: tools/podofoimpose/impositionplan.h
===================================================================
--- tools/podofoimpose/impositionplan.h	(revision 1792)
+++ tools/podofoimpose/impositionplan.h	(revision 1793)
@@ -85,7 +85,6 @@
 		PageRecord( );
 		~PageRecord() {};
 		int sourcePage;
-		int xobjIndex;
 		int destPage;
 		double rotate;
 		double transX;
Index: tools/podofoimpose/pdftranslator.cpp
===================================================================
--- tools/podofoimpose/pdftranslator.cpp	(revision 1792)
+++ tools/podofoimpose/pdftranslator.cpp	(revision 1793)
@@ -74,10 +74,17 @@
 		PdfTranslator::PdfTranslator ( )
 		{
 			std::cerr<<"PdfTranslator::PdfTranslator"<<std::endl;
-			sourceDoc = 0;
-			targetDoc = 0;
+			sourceDoc = NULL;
+			targetDoc = NULL;
+			planImposition = NULL;
+			duplicate = 0;
 			extraSpace = 0;
 			scaleFactor = 1.0;
+			pcount = 0;
+			sourceWidth = 0.0;
+			sourceHeight = 0.0;
+			destWidth = 0.0;
+			destHeight = 0.0;
 		}
 
 		void PdfTranslator::setSource ( const std::string & source )
@@ -111,7 +118,7 @@
 				}
 				while ( !in.eof() );
 				in.close();
-				delete filenameBuffer;
+				delete [] filenameBuffer;
 			}
 			std::cerr<< ++dbg <<std::endl;
 
Index: tools/podofopages/podofopages.cpp
===================================================================
--- tools/podofopages/podofopages.cpp	(revision 1792)
+++ tools/podofopages/podofopages.cpp	(revision 1793)
@@ -49,14 +49,14 @@
   printf("Usage: podofopages [inputfile] [outputfile]\n");
   printf("Options:\n");
   printf("\t--delete NUMBER\n");
-  printf("\tDeletes the page NUMBER (number is 0-based)\n"); 
+  printf("\tDeletes the page NUMBER (number is 0-based)\n");
   printf("\tThe page will not really be deleted from the PDF.\n");
   printf("\tIt is only removed from the so called pagestree and\n");
   printf("\ttherefore invisible. The content of the page can still\n");
   printf("\tbe retrieved from the document though.\n\n");
   printf("\t--move FROM TO\n");
-  printf("\tMoves a page FROM TO in the document (FROM and TO are 0-based)\n\n"); 
-  printf("\nPoDoFo Version: %s\n\n", PODOFO_VERSION_STRING);  
+  printf("\tMoves a page FROM TO in the document (FROM and TO are 0-based)\n\n");
+  printf("\nPoDoFo Version: %s\n\n", PODOFO_VERSION_STRING);
 }
 
 void work(const char* pszInput, const char* pszOutput, std::vector<Operation*> & rvecOperations)
@@ -63,13 +63,13 @@
 {
     std::cout << "Input file: " << pszInput << std::endl;
     std::cout << "Output file: " << pszOutput << std::endl;
-    
+
     PdfMemDocument doc(pszInput);
 
     int total = rvecOperations.size();
     int i = 1;
     std::vector<Operation*>::iterator it = rvecOperations.begin();
-    while( it != rvecOperations.end() ) 
+    while( it != rvecOperations.end() )
     {
         std::string msg = (*it)->ToString();
         std::cout << "Operation " << i << " of " << total << ": " << msg;
@@ -109,30 +109,30 @@
 
   // Fill operations vector
   std::vector<Operation*> vecOperations;
-  for( int i=1; i < argc; i++ ) 
+  for( int i=1; i < argc; i++ )
   {
       std::string argument = argv[i];
-      if( argument == "--delete" || argument == "-delete" ) 
+      if( argument == "--delete" || argument == "-delete" )
       {
           int page = static_cast<int>(convertToInt( std::string(argv[i+1]) ));
           vecOperations.push_back( new DeleteOperation( page ) );
           ++i;
       }
-      else if( argument == "--move" || argument == "-move" ) 
+      else if( argument == "--move" || argument == "-move" )
       {
           int from = static_cast<int>(convertToInt( std::string(argv[i+1]) ));
           int to = static_cast<int>(convertToInt( std::string(argv[i+2]) ));
           vecOperations.push_back( new MoveOperation( from, to ) );
           ++i;
-          ++i;          
+          ++i;
       }
       else
       {
-          if( pszInput == NULL ) 
+          if( pszInput == NULL )
           {
               pszInput = argv[i];
           }
-          else if( pszOutput == NULL ) 
+          else if( pszOutput == NULL )
           {
               pszOutput = argv[i];
           }
@@ -143,19 +143,19 @@
       }
   }
 
-  if( !pszInput ) 
+  if( !pszInput )
   {
       std::cerr << "Please specify an input file." << std::endl;
       exit( -2 );
   }
 
-  if( !pszOutput ) 
+  if( !pszOutput )
   {
       std::cerr << "Please specify an output file." << std::endl;
       exit( -3 );
   }
 
-  if( std::string(pszInput) == std::string(pszOutput) ) 
+  if( std::string(pszInput) == std::string(pszOutput) )
   {
       std::cerr << "Input and outpuf file must point to different files." << std::endl;
       exit( -4 );
@@ -167,11 +167,14 @@
       std::cerr << "Error: An error " << e.GetError() << " ocurred." << std::endl;
       e.PrintErrorMsg();
       return e.GetError();
+  } catch( std::runtime_error & re ) {
+      std::cerr << "Error: An error " << re.what() << " ocurred." << std::endl;
+      return -1;
   }
 
   // Delete operations vectore
   std::vector<Operation*>::iterator it = vecOperations.begin();
-  while( it != vecOperations.end() ) 
+  while( it != vecOperations.end() )
   {
       delete (*it);
       ++it;
#Index: tools/podofosign/podofosign.cpp
#===================================================================
#--- tools/podofosign/podofosign.cpp	(revision 1792)
#+++ tools/podofosign/podofosign.cpp	(revision 1793)
#@@ -180,17 +180,17 @@
#     if( !pkey )
#         PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidHandle, "pkey == NULL" );
# 
#-    unsigned int buffLen = 65535, len;
#-    char *buff;
#+    unsigned int uBufferLen = 65535, len;
#+    char *pBuffer;
# 
#-    while( buff = reinterpret_cast<char *>( malloc( sizeof( char ) * buffLen) ), !buff )
#+    while( pBuffer = reinterpret_cast<char *>( podofo_malloc( sizeof( char ) * uBufferLen) ), !pBuffer )
#     {
#-        buffLen = buffLen / 2;
#-        if( !buffLen )
#+        uBufferLen = uBufferLen / 2;
#+        if( !uBufferLen )
#             break;
#     }
# 
#-    if( !buff )
#+    if( !pBuffer )
#         PODOFO_RAISE_ERROR (ePdfError_OutOfMemory);
# 
#     int rc;
#@@ -197,7 +197,7 @@
#     BIO *mem = BIO_new( BIO_s_mem() );
#     if( !mem )
#     {
#-        free( buff );
#+        podofo_free( pBuffer );
#         raise_podofo_error_with_opensslerror( "Failed to create input BIO" );
#     }
# 
#@@ -206,23 +206,23 @@
#     if( !pkcs7 )
#     {
#         BIO_free( mem );
#-        free( buff );
#+        podofo_free( pBuffer );
#         raise_podofo_error_with_opensslerror( "PKCS7_sign failed" );
#     }
# 
#-    while( len = signer.ReadForSignature( buff, buffLen ), len > 0 )
#+    while( len = signer.ReadForSignature( pBuffer, uBufferLen ), len > 0 )
#     {
#-        rc = BIO_write( mem, buff, len );
#+        rc = BIO_write( mem, pBuffer, len );
#         if( static_cast<unsigned int>( rc ) != len )
#         {
#             PKCS7_free( pkcs7 );
#             BIO_free( mem );
#-            free( buff );
#+            podofo_free( pBuffer );
#             raise_podofo_error_with_opensslerror( "BIO_write failed" );
#         }
#     }
# 
#-    free( buff );
#+    podofo_free( pBuffer );
# 
#     if( PKCS7_final( pkcs7, mem, flags ) <= 0 )
#     {
#@@ -714,8 +714,14 @@
#                 return -5;
#             }
# 
#-            if( *value == annot_position && !parse_annot_position( annot_position, annot_units, annot_page, annot_left, annot_top, annot_width, annot_height ) )
#-            {
#+            try {
#+                if( *value == annot_position && !parse_annot_position( annot_position, annot_units, annot_page, annot_left, annot_top, annot_width, annot_height ) )
#+                {
#+                    std::cerr << "Invalid -annot-position value '" << *value << "', expected format \"page,left,top,width,height\"" << std::endl;
#+
#+                    return -6;
#+                }
#+            } catch( PdfError & e ) {
#                 std::cerr << "Invalid -annot-position value '" << *value << "', expected format \"page,left,top,width,height\"" << std::endl;
# 
#                 return -6;
Index: tools/podofotxt2pdf/podofotxt2pdf.cpp
===================================================================
--- tools/podofotxt2pdf/podofotxt2pdf.cpp	(revision 1792)
+++ tools/podofotxt2pdf/podofotxt2pdf.cpp	(revision 1793)
@@ -117,8 +117,8 @@
 
     PdfStreamedDocument doc( pszOutput );
 
-    char*  pszBuf;
-    size_t lSize;
+    char* pszBuf;
+    long lSize;
 
     hFile = fopen( pszInput, "rb" );	// read it as binary if we are going to compare sizes!
     if( !hFile )
@@ -126,13 +126,24 @@
         PODOFO_RAISE_ERROR( ePdfError_InvalidHandle );
     }
 
-    fseek( hFile, 0x00, SEEK_END );
+    if( fseek( hFile, 0x00, SEEK_END ) == -1 )
+    {
+        fclose( hFile );
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to seek to the end of the file" );
+    }
+
     lSize  = ftell( hFile );
+    if( lSize == -1 )
+    {
+        fclose( hFile );
+        PODOFO_RAISE_ERROR_INFO( ePdfError_InvalidDeviceOperation, "Failed to read size of the file" );
+    }
 
     pszBuf = static_cast<char*>(malloc( sizeof( char ) * (lSize+1) ));
     fseek( hFile, 0x00, SEEK_SET );
     if( !pszBuf )
     {
+        fclose( hFile );
         PODOFO_RAISE_ERROR( ePdfError_OutOfMemory );
     }
 
@@ -140,9 +151,10 @@
     // this not very efficient, but as this is 
     // a library demonstration I do not care.
     // If anyone wants to improve this: Go for it!
-    if( fread( pszBuf, sizeof(char), lSize, hFile ) != lSize )
+    if( static_cast<long>( fread( pszBuf, sizeof(char), lSize, hFile ) ) != lSize )
     {
         free( pszBuf );
+        fclose( hFile );
         PODOFO_RAISE_ERROR( ePdfError_UnexpectedEOF );
     }
 
